$(() => {
const tab1 = $('#withText').dxTabs({
width: 'auto',
rtlEnabled: false,
selectedIndex: 0,
showNavButtons: false,
dataSource: tabsText,
orientation: orientations[0],
stylingMode: stylingModes[1],
iconPosition: iconPositions[0],
}).dxTabs('instance');
const tab2 = $('#withIconAndText').dxTabs({
width: 'auto',
rtlEnabled: false,
selectedIndex: 0,
showNavButtons: false,
dataSource: tabsIconAndText,
orientation: orientations[0],
stylingMode: stylingModes[1],
iconPosition: iconPositions[0],
}).dxTabs('instance');
const tab3 = $('#withIcon').dxTabs({
width: 'auto',
rtlEnabled: false,
selectedIndex: 0,
showNavButtons: false,
dataSource: tabsIcon,
orientation: orientations[0],
stylingMode: stylingModes[1],
iconPosition: iconPositions[0],
}).dxTabs('instance');
$('#orientation').dxSelectBox({
items: orientations,
value: orientations[0],
inputAttr: { 'aria-label': 'Orientation' },
onValueChanged(data) {
const $widgetWrapper = $('.widget-wrapper');
const isVertical = data.value === 'vertical';
$widgetWrapper.toggleClass('widget-wrapper-vertical', isVertical);
$widgetWrapper.toggleClass('widget-wrapper-horizontal', !isVertical);
setTabsOption('orientation', data.value);
},
});
$('#styling-mode').dxSelectBox({
items: stylingModes,
value: stylingModes[1],
inputAttr: { 'aria-label': 'Styling Mode' },
onValueChanged(data) {
setTabsOption('stylingMode', data.value);
},
});
$('#icon-position').dxSelectBox({
items: iconPositions,
inputAttr: { 'aria-label': 'Icon Position' },
value: iconPositions[0],
onValueChanged(data) {
setTabsOption('iconPosition', data.value);
},
});
const showNavButtonsCheckBox = $('#show-navigation-buttons').dxCheckBox({
text: 'Show navigation buttons',
value: false,
onValueChanged(data) {
const shouldRestrictWidth = data.value || scrollContentCheckBox.option('value');
toggleStrictWidthClass(shouldRestrictWidth);
setTabsOption('showNavButtons', data.value);
},
}).dxCheckBox('instance');
const scrollContentCheckBox = $('#scroll-content').dxCheckBox({
text: 'Scroll content',
value: false,
onValueChanged(data) {
const shouldRestrictWidth = data.value || showNavButtonsCheckBox.option('value');
toggleStrictWidthClass(shouldRestrictWidth);
setTabsOption('scrollByContent', data.value);
},
}).dxCheckBox('instance');
$('#full-width').dxCheckBox({
text: 'Full width',
value: false,
onValueChanged(data) {
setTabsOption('width', data.value ? '100%' : 'auto');
},
});
$('#rtl').dxCheckBox({
text: 'Right-to-left mode',
value: false,
onValueChanged(data) {
setTabsOption('rtlEnabled', data.value);
},
});
function setTabsOption(option, value) {
tab1.option(option, value);
tab2.option(option, value);
tab3.option(option, value);
}
function toggleStrictWidthClass(shouldRestrictWidth) {
const $widgetWrapper = $('.widget-wrapper');
$widgetWrapper.toggleClass('strict-width', shouldRestrictWidth);
}
});
<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
<script>window.jQuery || document.write(decodeURIComponent('%3Cscript src="js/jquery.min.js"%3E%3C/script%3E'))</script>
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/25.1.6/css/dx.light.css" />
<script src="js/dx.all.js?v=25.1.6"></script>
<script src="data.js"></script>
<link rel="stylesheet" type="text/css" href="styles.css" />
<script src="index.js"></script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div class="tabs-demo">
<div class="widget-container">
<div class="widget-wrapper widget-wrapper-horizontal">
<div id="withText"></div>
<div id="withIconAndText"></div>
<div id="withIcon"></div>
</div>
</div>
<div class="options">
<div class="caption">Options</div>
<div class="option">
<span>Orientation</span>
<div id="orientation"></div>
</div>
<div class="option">
<span>Styling mode</span>
<div id="styling-mode"></div>
</div>
<div class="option">
<span>Icon position</span>
<div id="icon-position"></div>
</div>
<div class="option">
<div id="show-navigation-buttons"></div>
</div>
<div class="option">
<div id="scroll-content"></div>
</div>
<div class="option">
<div id="full-width"></div>
</div>
<div class="option">
<div id="rtl"></div>
</div>
</div>
</div>
</div>
</body>
</html>
.tabs-demo {
display: flex;
}
.strict-width {
max-width: 340px;
}
.dx-theme-generic .strict-width {
max-width: 250px;
}
.widget-container {
display: flex;
align-items: center;
justify-content: center;
flex-grow: 1;
width: 100%;
min-width: 200px;
padding: 16px 32px;
overflow: clip;
}
.widget-wrapper {
display: inline-flex;
flex-direction: column;
align-items: center;
justify-content: center;
gap: 80px;
width: 100%;
}
.widget-wrapper-vertical {
width: 100%;
flex-direction: row;
align-items: center;
}
.options {
display: flex;
flex-direction: column;
flex-shrink: 0;
padding: 20px;
background-color: rgba(191, 191, 191, 0.15);
}
.caption {
font-weight: 500;
font-size: 18px;
}
#show-navigation-buttons {
margin-top: 22px;
}
.option {
margin-top: 20px;
}
.dx-tabs {
max-width: 100%;
}
.dx-tabs-vertical {
height: 216px;
}
.dx-viewport:not(.dx-theme-generic) .dx-tabs-horizontal {
border-block-end: 1px solid rgb(225, 225, 225, 0.4);
}
.dx-viewport:not(.dx-theme-generic) .dx-tabs-vertical {
height: 232px;
border-inline-end: 1px solid rgb(225, 225, 225, 0.4);
}
const tabsText = [
{
id: 0,
text: 'User',
},
{
id: 1,
text: 'Analytics',
},
{
id: 2,
text: 'Clients',
},
{
id: 3,
text: 'Orders',
},
{
id: 4,
text: 'Favorites',
},
{
id: 5,
text: 'Search',
},
];
const tabsIconAndText = [
{
id: 0,
text: 'User',
icon: 'user',
},
{
id: 1,
text: 'Analytics',
icon: 'chart',
},
{
id: 2,
text: 'Clients',
icon: 'accountbox',
},
{
id: 3,
text: 'Orders',
icon: 'ordersbox',
},
{
id: 4,
text: 'Favorites',
icon: 'bookmark',
},
{
id: 5,
text: 'Search',
icon: 'search',
},
];
const tabsIcon = [
{
id: 0,
icon: 'user',
},
{
id: 1,
icon: 'chart',
},
{
id: 2,
icon: 'accountbox',
},
{
id: 3,
icon: 'ordersbox',
},
{
id: 4,
icon: 'bookmark',
},
{
id: 5,
icon: 'search',
},
];
const orientations = ['horizontal', 'vertical'];
const stylingModes = [
'primary',
'secondary',
];
const iconPositions = [
'top',
'start',
'end',
'bottom',
];

import React, { useCallback, useState } from 'react';
import Tabs from 'devextreme-react/tabs';
import SelectBox from 'devextreme-react/select-box';
import CheckBox from 'devextreme-react/check-box';
import {
orientations,
tabsText,
stylingModeLabel,
iconPositionLabel,
tabsIconAndText,
stylingModes,
iconPositions,
tabsIcon,
orientationLabel,
} from './data.ts';
const STRICT_WIDTH_CLASS = 'strict-width';
function OptionWrapper(props) {
return (
<div className="option">
{props.caption && <span>{props.caption}</span>}
{props.children}
</div>
);
}
const App = () => {
const [orientation, setOrientation] = useState(orientations[0]);
const [stylingMode, setStylingMode] = useState(stylingModes[1]);
const [iconPosition, setIconPosition] = useState(iconPositions[0]);
const [showNavigation, setShowNavigation] = useState(false);
const [scrollContent, setScrollContent] = useState(false);
const [fullWidth, setFullWidth] = useState(false);
const [width, setWidth] = useState('auto');
const [rtlEnabled, setRtlEnabled] = useState(false);
const [widgetWrapperClasses, setWidgetWrapperClasses] = useState('widget-wrapper widget-wrapper-horizontal');
const enforceWidthConstraint = useCallback(
(shouldRestrictWidth) => {
const callback = (prevClasses: string) => {
const restClasses = prevClasses.split(' ').filter((className) => className !== STRICT_WIDTH_CLASS).join(' ');
const strictWidthClass = shouldRestrictWidth ? STRICT_WIDTH_CLASS : '';
return `${restClasses} ${strictWidthClass}`;
};
setWidgetWrapperClasses(callback);
}, [setWidgetWrapperClasses],
);
const stylingModeChanged = useCallback((e) => {
setStylingMode(e.value);
}, [setStylingMode]);
const iconPositionChanged = useCallback((e) => {
setIconPosition(e.value);
}, [setIconPosition]);
const orientationChanged = useCallback((e) => {
const isVertical = e.value === 'vertical';
const callback = (prevClasses: string) => {
const restClasses = prevClasses
.split(' ')
.filter((className) => (className !== (isVertical ? 'widget-wrapper-horizontal' : 'widget-wrapper-vertical')))
.join(' ');
return `${restClasses} widget-wrapper-${e.value}`;
};
setWidgetWrapperClasses(callback);
setOrientation(e.value);
}, [setOrientation, setWidgetWrapperClasses]);
const showNavigationChanged = useCallback((e) => {
const shouldRestrictWidth = e.value || scrollContent;
enforceWidthConstraint(shouldRestrictWidth);
setShowNavigation(e.value);
}, [scrollContent, setShowNavigation, enforceWidthConstraint]);
const scrollContentChanged = useCallback((e) => {
const shouldRestrictWidth = e.value || showNavigation;
enforceWidthConstraint(shouldRestrictWidth);
setScrollContent(e.value);
}, [showNavigation, setScrollContent, enforceWidthConstraint]);
const fullWidthChanged = useCallback((e) => {
setFullWidth(e.value);
setWidth(e.value ? '100%' : 'auto');
}, [setFullWidth, setWidth]);
const rtlEnabledChanged = useCallback((e) => {
setRtlEnabled(e.value);
}, [setRtlEnabled]);
return (
<div className="tabs-demo">
<div className="widget-container">
<div className={widgetWrapperClasses}>
<Tabs
id="withText"
width={width}
defaultSelectedIndex={0}
rtlEnabled={rtlEnabled}
dataSource={tabsText}
scrollByContent={scrollContent}
showNavButtons={showNavigation}
orientation={orientation}
stylingMode={stylingMode}
iconPosition={iconPosition}
/>
<Tabs
id="withIconAndText"
width={width}
defaultSelectedIndex={0}
rtlEnabled={rtlEnabled}
dataSource={tabsIconAndText}
scrollByContent={scrollContent}
showNavButtons={showNavigation}
orientation={orientation}
stylingMode={stylingMode}
iconPosition={iconPosition}
/>
<Tabs
id="withIcon"
width={width}
defaultSelectedIndex={0}
rtlEnabled={rtlEnabled}
dataSource={tabsIcon}
scrollByContent={scrollContent}
showNavButtons={showNavigation}
orientation={orientation}
stylingMode={stylingMode}
iconPosition={iconPosition}
/>
</div>
</div>
<div className="options">
<div className="caption">Options</div>
<OptionWrapper caption='Orientation'>
<SelectBox
items={orientations}
inputAttr={orientationLabel}
value={orientation}
onValueChanged={orientationChanged}
/>
</OptionWrapper>
<OptionWrapper caption='Styling mode'>
<SelectBox
items={stylingModes}
inputAttr={stylingModeLabel}
value={stylingMode}
onValueChanged={stylingModeChanged}
/>
</OptionWrapper>
<OptionWrapper caption='Icon position'>
<SelectBox
items={iconPositions}
inputAttr={iconPositionLabel}
value={iconPosition}
onValueChanged={iconPositionChanged}
/>
</OptionWrapper>
<div className="option">
<CheckBox
id="show-navigation-buttons"
text="Show navigation buttons"
value={showNavigation}
onValueChanged={showNavigationChanged}
/>
</div>
<div className="option">
<CheckBox
text="Scroll content"
value={scrollContent}
onValueChanged={scrollContentChanged}
/>
</div>
<div className="option">
<CheckBox
text="Full width"
value={fullWidth}
onValueChanged={fullWidthChanged}
/>
</div>
<div className="option">
<CheckBox
text="Right-to-left mode"
value={rtlEnabled}
onValueChanged={rtlEnabledChanged}
/>
</div>
</div>
</div>
);
};
export default App;
import React, { useCallback, useState } from 'react';
import Tabs from 'devextreme-react/tabs';
import SelectBox from 'devextreme-react/select-box';
import CheckBox from 'devextreme-react/check-box';
import {
orientations,
tabsText,
stylingModeLabel,
iconPositionLabel,
tabsIconAndText,
stylingModes,
iconPositions,
tabsIcon,
orientationLabel,
} from './data.js';
const STRICT_WIDTH_CLASS = 'strict-width';
function OptionWrapper(props) {
return (
<div className="option">
{props.caption && <span>{props.caption}</span>}
{props.children}
</div>
);
}
const App = () => {
const [orientation, setOrientation] = useState(orientations[0]);
const [stylingMode, setStylingMode] = useState(stylingModes[1]);
const [iconPosition, setIconPosition] = useState(iconPositions[0]);
const [showNavigation, setShowNavigation] = useState(false);
const [scrollContent, setScrollContent] = useState(false);
const [fullWidth, setFullWidth] = useState(false);
const [width, setWidth] = useState('auto');
const [rtlEnabled, setRtlEnabled] = useState(false);
const [widgetWrapperClasses, setWidgetWrapperClasses] = useState(
'widget-wrapper widget-wrapper-horizontal',
);
const enforceWidthConstraint = useCallback(
(shouldRestrictWidth) => {
const callback = (prevClasses) => {
const restClasses = prevClasses
.split(' ')
.filter((className) => className !== STRICT_WIDTH_CLASS)
.join(' ');
const strictWidthClass = shouldRestrictWidth ? STRICT_WIDTH_CLASS : '';
return `${restClasses} ${strictWidthClass}`;
};
setWidgetWrapperClasses(callback);
},
[setWidgetWrapperClasses],
);
const stylingModeChanged = useCallback(
(e) => {
setStylingMode(e.value);
},
[setStylingMode],
);
const iconPositionChanged = useCallback(
(e) => {
setIconPosition(e.value);
},
[setIconPosition],
);
const orientationChanged = useCallback(
(e) => {
const isVertical = e.value === 'vertical';
const callback = (prevClasses) => {
const restClasses = prevClasses
.split(' ')
.filter(
(className) =>
className !== (isVertical ? 'widget-wrapper-horizontal' : 'widget-wrapper-vertical'),
)
.join(' ');
return `${restClasses} widget-wrapper-${e.value}`;
};
setWidgetWrapperClasses(callback);
setOrientation(e.value);
},
[setOrientation, setWidgetWrapperClasses],
);
const showNavigationChanged = useCallback(
(e) => {
const shouldRestrictWidth = e.value || scrollContent;
enforceWidthConstraint(shouldRestrictWidth);
setShowNavigation(e.value);
},
[scrollContent, setShowNavigation, enforceWidthConstraint],
);
const scrollContentChanged = useCallback(
(e) => {
const shouldRestrictWidth = e.value || showNavigation;
enforceWidthConstraint(shouldRestrictWidth);
setScrollContent(e.value);
},
[showNavigation, setScrollContent, enforceWidthConstraint],
);
const fullWidthChanged = useCallback(
(e) => {
setFullWidth(e.value);
setWidth(e.value ? '100%' : 'auto');
},
[setFullWidth, setWidth],
);
const rtlEnabledChanged = useCallback(
(e) => {
setRtlEnabled(e.value);
},
[setRtlEnabled],
);
return (
<div className="tabs-demo">
<div className="widget-container">
<div className={widgetWrapperClasses}>
<Tabs
id="withText"
width={width}
defaultSelectedIndex={0}
rtlEnabled={rtlEnabled}
dataSource={tabsText}
scrollByContent={scrollContent}
showNavButtons={showNavigation}
orientation={orientation}
stylingMode={stylingMode}
iconPosition={iconPosition}
/>
<Tabs
id="withIconAndText"
width={width}
defaultSelectedIndex={0}
rtlEnabled={rtlEnabled}
dataSource={tabsIconAndText}
scrollByContent={scrollContent}
showNavButtons={showNavigation}
orientation={orientation}
stylingMode={stylingMode}
iconPosition={iconPosition}
/>
<Tabs
id="withIcon"
width={width}
defaultSelectedIndex={0}
rtlEnabled={rtlEnabled}
dataSource={tabsIcon}
scrollByContent={scrollContent}
showNavButtons={showNavigation}
orientation={orientation}
stylingMode={stylingMode}
iconPosition={iconPosition}
/>
</div>
</div>
<div className="options">
<div className="caption">Options</div>
<OptionWrapper caption="Orientation">
<SelectBox
items={orientations}
inputAttr={orientationLabel}
value={orientation}
onValueChanged={orientationChanged}
/>
</OptionWrapper>
<OptionWrapper caption="Styling mode">
<SelectBox
items={stylingModes}
inputAttr={stylingModeLabel}
value={stylingMode}
onValueChanged={stylingModeChanged}
/>
</OptionWrapper>
<OptionWrapper caption="Icon position">
<SelectBox
items={iconPositions}
inputAttr={iconPositionLabel}
value={iconPosition}
onValueChanged={iconPositionChanged}
/>
</OptionWrapper>
<div className="option">
<CheckBox
id="show-navigation-buttons"
text="Show navigation buttons"
value={showNavigation}
onValueChanged={showNavigationChanged}
/>
</div>
<div className="option">
<CheckBox
text="Scroll content"
value={scrollContent}
onValueChanged={scrollContentChanged}
/>
</div>
<div className="option">
<CheckBox
text="Full width"
value={fullWidth}
onValueChanged={fullWidthChanged}
/>
</div>
<div className="option">
<CheckBox
text="Right-to-left mode"
value={rtlEnabled}
onValueChanged={rtlEnabledChanged}
/>
</div>
</div>
</div>
);
};
export default App;
import React from 'react';
import ReactDOM from 'react-dom';
import App from './App.tsx';
ReactDOM.render(
<App />,
document.getElementById('app'),
);
import { Orientation, TabsIconPosition, TabsStyle } from 'devextreme/common';
export const tabsText = [
{
id: 0,
text: 'User',
},
{
id: 1,
text: 'Analytics',
},
{
id: 2,
text: 'Clients',
},
{
id: 3,
text: 'Orders',
},
{
id: 4,
text: 'Favorites',
},
{
id: 5,
text: 'Search',
},
];
export const tabsIconAndText = [
{
id: 0,
text: 'User',
icon: 'user',
},
{
id: 1,
text: 'Analytics',
icon: 'chart',
},
{
id: 2,
text: 'Clients',
icon: 'accountbox',
},
{
id: 3,
text: 'Orders',
icon: 'ordersbox',
},
{
id: 4,
text: 'Favorites',
icon: 'bookmark',
},
{
id: 5,
text: 'Search',
icon: 'search',
},
];
export const tabsIcon = [
{
id: 0,
icon: 'user',
},
{
id: 1,
icon: 'chart',
},
{
id: 2,
icon: 'accountbox',
},
{
id: 3,
icon: 'ordersbox',
},
{
id: 4,
icon: 'bookmark',
},
{
id: 5,
icon: 'search',
},
];
export const orientations: Orientation[] = ['horizontal', 'vertical'];
export const stylingModes: TabsStyle[] = [
'primary',
'secondary',
];
export const orientationLabel = { 'aria-label': 'Orientation' };
export const stylingModeLabel = { 'aria-label': 'Styling Mode' };
export const iconPositionLabel = { 'aria-label': 'Icon Position' };
export const iconPositions: TabsIconPosition[] = [
'top',
'start',
'end',
'bottom',
];
window.exports = window.exports || {};
window.config = {
transpiler: 'ts',
typescriptOptions: {
module: 'system',
emitDecoratorMetadata: true,
experimentalDecorators: true,
jsx: 'react',
},
meta: {
'react': {
'esModule': true,
},
'typescript': {
'exports': 'ts',
},
'devextreme/time_zone_utils.js': {
'esModule': true,
},
'devextreme/localization.js': {
'esModule': true,
},
'devextreme/viz/palette.js': {
'esModule': true,
},
},
paths: {
'npm:': 'https://unpkg.com/',
},
defaultExtension: 'js',
map: {
'ts': 'npm:plugin-typescript@4.2.4/lib/plugin.js',
'typescript': 'npm:typescript@4.2.4/lib/typescript.js',
'react': 'npm:react@17.0.2/umd/react.development.js',
'react-dom': 'npm:react-dom@17.0.2/umd/react-dom.development.js',
'prop-types': 'npm:prop-types@15.8.1/prop-types.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@1.28.1/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign@1.1.0',
'devextreme': 'npm:devextreme@24.1.7/cjs',
'devextreme-react': 'npm:devextreme-react@24.1.7/cjs',
'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js',
'devextreme-quill': 'npm:devextreme-quill@1.7.1/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.13/dist/dx-diagram.js',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.56/dist/dx-gantt.js',
'@devextreme/runtime': 'npm:@devextreme/runtime@3.0.13',
'inferno': 'npm:inferno@7.4.11/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@7.4.11/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate@7.4.11/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
'devextreme-cldr-data': 'npm:devextreme-cldr-data@1.0.3',
// SystemJS plugins
'plugin-babel': 'npm:systemjs-plugin-babel@0.0.25/plugin-babel.js',
'systemjs-babel-build': 'npm:systemjs-plugin-babel@0.0.25/systemjs-babel-browser.js',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.8/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js',
},
packages: {
'devextreme': {
defaultExtension: 'js',
},
'devextreme-react': {
main: 'index.js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/localization/messages': {
format: 'json',
defaultExtension: 'json',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
'npm:@devextreme/runtime@3.0.13/inferno/package.json',
],
babelOptions: {
sourceMaps: false,
stage0: true,
react: true,
},
};
System.config(window.config);
import React from 'react';
import ReactDOM from 'react-dom';
import App from './App.js';
ReactDOM.render(<App />, document.getElementById('app'));
export const tabsText = [
{
id: 0,
text: 'User',
},
{
id: 1,
text: 'Analytics',
},
{
id: 2,
text: 'Clients',
},
{
id: 3,
text: 'Orders',
},
{
id: 4,
text: 'Favorites',
},
{
id: 5,
text: 'Search',
},
];
export const tabsIconAndText = [
{
id: 0,
text: 'User',
icon: 'user',
},
{
id: 1,
text: 'Analytics',
icon: 'chart',
},
{
id: 2,
text: 'Clients',
icon: 'accountbox',
},
{
id: 3,
text: 'Orders',
icon: 'ordersbox',
},
{
id: 4,
text: 'Favorites',
icon: 'bookmark',
},
{
id: 5,
text: 'Search',
icon: 'search',
},
];
export const tabsIcon = [
{
id: 0,
icon: 'user',
},
{
id: 1,
icon: 'chart',
},
{
id: 2,
icon: 'accountbox',
},
{
id: 3,
icon: 'ordersbox',
},
{
id: 4,
icon: 'bookmark',
},
{
id: 5,
icon: 'search',
},
];
export const orientations = ['horizontal', 'vertical'];
export const stylingModes = ['primary', 'secondary'];
export const orientationLabel = { 'aria-label': 'Orientation' };
export const stylingModeLabel = { 'aria-label': 'Styling Mode' };
export const iconPositionLabel = { 'aria-label': 'Icon Position' };
export const iconPositions = ['top', 'start', 'end', 'bottom'];
<!DOCTYPE html>
<html lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/24.1.7/css/dx.light.css" />
<link rel="stylesheet" type="text/css" href="styles.css" />
<script src="https://unpkg.com/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://unpkg.com/systemjs@0.21.3/dist/system.js"></script>
<script type="text/javascript" src="config.js"></script>
<script type="text/javascript">
System.import("./index.tsx");
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div id="app"></div>
</div>
</body>
</html>
.tabs-demo {
display: flex;
}
.strict-width {
max-width: 340px;
}
.dx-theme-generic .strict-width {
max-width: 250px;
}
.widget-container {
display: flex;
align-items: center;
justify-content: center;
flex-grow: 1;
width: 100%;
min-width: 200px;
padding: 16px 32px;
overflow: clip;
}
.widget-wrapper {
display: inline-flex;
flex-direction: column;
align-items: center;
justify-content: center;
gap: 80px;
width: 100%;
}
.widget-wrapper-vertical {
width: 100%;
flex-direction: row;
align-items: center;
}
.options {
display: flex;
flex-direction: column;
flex-shrink: 0;
padding: 20px;
background-color: rgba(191, 191, 191, 0.15);
}
.caption {
font-weight: 500;
font-size: 18px;
}
#show-navigation-buttons {
margin-top: 22px;
}
.option {
margin-top: 20px;
}
.dx-tabs {
max-width: 100%;
}
.dx-tabs-vertical {
height: 216px;
}
.dx-viewport:not(.dx-theme-generic) .dx-tabs-horizontal {
border-block-end: 1px solid rgb(225, 225, 225, 0.4);
}
.dx-viewport:not(.dx-theme-generic) .dx-tabs-vertical {
height: 232px;
border-inline-end: 1px solid rgb(225, 225, 225, 0.4);
}

<template>
<div class="tabs-demo">
<div class="widget-container">
<div :class="widgetWrapperClasses">
<DxTabs
v-for="(dataSource, index) in dataSources"
:key="index"
:selected-index="0"
:width="tabsWidth"
:rtl-enabled="rtlEnabled"
:data-source="dataSource"
:orientation="orientation"
:styling-mode="stylingMode"
:icon-position="iconPosition"
:show-nav-buttons="showNavButtons"
:scroll-by-content="scrollByContent"
/>
</div>
</div>
<div class="options">
<div class="caption">Options</div>
<div class="option">
<span>Orientation</span>
<DxSelectBox
:items="orientations"
:input-attr="{ 'aria-label': 'Orientation' }"
v-model:value="orientation"
/>
</div>
<div class="option">
<span>Styling mode</span>
<DxSelectBox
:items="stylingModes"
:input-attr="{ 'aria-label': 'Styling Mode' }"
v-model:value="stylingMode"
/>
</div>
<div class="option">
<span>Icon position</span>
<DxSelectBox
:items="iconPositions"
:input-attr="{ 'aria-label': 'Icon Position' }"
v-model:value="iconPosition"
/>
</div>
<div class="option">
<DxCheckBox
id="show-navigation-buttons"
text="Show navigation buttons"
v-model:value="showNavButtons"
/>
</div>
<div class="option">
<DxCheckBox
text="Scroll content"
v-model:value="scrollByContent"
/>
</div>
<div class="option">
<DxCheckBox
text="Full width"
v-model:value="fullWidth"
/>
</div>
<div class="option">
<DxCheckBox
text="Right-to-left mode"
v-model:value="rtlEnabled"
/>
</div>
</div>
</div>
</template>
<script setup lang="ts">
import { ref, computed, watch } from 'vue';
import DxSelectBox from 'devextreme-vue/select-box';
import DxCheckBox from 'devextreme-vue/check-box';
import DxTabs from 'devextreme-vue/tabs';
import {
orientations,
stylingModes,
iconPositions,
tabsWithText,
tabsWithIconAndText,
tabsWithIcon,
} from './data.ts';
const fullWidth = ref(false);
const rtlEnabled = ref(false);
const scrollByContent = ref(false);
const showNavButtons = ref(false);
const shouldRestrictWidth = ref(false);
const orientation = ref(orientations[0]);
const iconPosition = ref(iconPositions[0]);
const stylingMode = ref(stylingModes[1]);
const widgetWrapperClasses = computed(() => [
'widget-wrapper',
`widget-wrapper-${orientation.value}`,
shouldRestrictWidth.value && 'strict-width',
]);
const tabsWidth = computed(() => (fullWidth.value ? '100%' : 'auto'));
const dataSources = computed(() => [
tabsWithText,
tabsWithIconAndText,
tabsWithIcon,
]);
const enforceWidthConstraint = () => {
shouldRestrictWidth.value = scrollByContent.value || showNavButtons.value;
};
watch(showNavButtons, enforceWidthConstraint);
watch(scrollByContent, enforceWidthConstraint);
</script>
<style>
.tabs-demo {
display: flex;
}
.strict-width {
max-width: 340px;
}
.dx-theme-generic .strict-width {
max-width: 250px;
}
.widget-container {
display: flex;
align-items: center;
justify-content: center;
flex-grow: 1;
width: 100%;
min-width: 200px;
padding: 16px 32px;
overflow: clip;
}
.widget-wrapper {
display: inline-flex;
flex-direction: column;
align-items: center;
justify-content: center;
gap: 80px;
width: 100%;
}
.widget-wrapper-vertical {
width: 100%;
flex-direction: row;
align-items: center;
}
.options {
display: flex;
flex-direction: column;
flex-shrink: 0;
padding: 20px;
background-color: rgba(191, 191, 191, 0.15);
}
.caption {
font-weight: 500;
font-size: 18px;
}
#show-navigation-buttons {
margin-top: 22px;
}
.option {
margin-top: 20px;
}
.dx-tabs {
max-width: 100%;
}
.dx-tabs-vertical {
height: 216px;
}
.dx-viewport:not(.dx-theme-generic) .dx-tabs-horizontal {
border-block-end: 1px solid rgb(225, 225, 225, 0.4);
}
.dx-viewport:not(.dx-theme-generic) .dx-tabs-vertical {
height: 232px;
border-inline-end: 1px solid rgb(225, 225, 225, 0.4);
}
</style>
window.exports = window.exports || {};
window.config = {
transpiler: 'plugin-babel',
meta: {
'*.vue': {
loader: 'vue-loader',
},
'*.ts': {
loader: 'demo-ts-loader',
},
'*.svg': {
loader: 'svg-loader',
},
'devextreme/time_zone_utils.js': {
'esModule': true,
},
'devextreme/localization.js': {
'esModule': true,
},
'devextreme/viz/palette.js': {
'esModule': true,
},
'openai': {
'esModule': true,
},
},
paths: {
'project:': '../../../../',
'npm:': 'https://cdn.jsdelivr.net/npm/',
'bundles:': '../../../../bundles/',
'externals:': '../../../../bundles/externals/',
'anti-forgery:': '../../../../shared/anti-forgery/',
},
map: {
'anti-forgery': 'anti-forgery:fetch-override.js',
'vue': 'npm:vue@3.4.27/dist/vue.esm-browser.js',
'@vue/shared': 'npm:@vue/shared@3.4.27/dist/shared.cjs.prod.js',
'vue-loader': 'npm:dx-systemjs-vue-browser@1.1.2/index.js',
'demo-ts-loader': 'project:utils/demo-ts-loader.js',
'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js',
'svg-loader': 'project:utils/svg-loader.js',
'mitt': 'npm:mitt/dist/mitt.umd.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign',
'devextreme': 'npm:devextreme@link:../../packages/devextreme/artifacts/npm/devextreme/cjs',
'devextreme-vue': 'npm:devextreme-vue@link:../../packages/devextreme-vue/npm/cjs',
'devextreme-quill': 'npm:devextreme-quill@1.7.8/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.25/dist/dx-diagram.js',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.67/dist/dx-gantt.js',
'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
'@preact/signals-core': 'npm:@preact/signals-core@1.8.0/dist/signals-core.min.js',
'plugin-babel': 'npm:systemjs-plugin-babel@0.0.25/plugin-babel.js',
'systemjs-babel-build': 'npm:systemjs-plugin-babel@0.0.25/systemjs-babel-browser.js',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.8/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js',
},
packages: {
'devextreme-vue': {
main: 'index.js',
},
'devextreme-vue/common': {
main: 'index.js',
},
'devextreme': {
defaultExtension: 'js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/common/core/events/utils': {
main: 'index',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
],
babelOptions: {
sourceMaps: false,
stage0: true,
},
};
window.process = {
env: {
NODE_ENV: 'production',
},
};
System.config(window.config);
// eslint-disable-next-line
const useTgzInCSB = ['openai'];
import { type Orientation } from 'devextreme/common';
import { type DxTabsTypes } from 'devextreme-vue/tabs';
export const tabsWithText = [
{
id: 0,
text: 'User',
},
{
id: 1,
text: 'Analytics',
},
{
id: 2,
text: 'Clients',
},
{
id: 3,
text: 'Orders',
},
{
id: 4,
text: 'Favorites',
},
{
id: 5,
text: 'Search',
},
];
export const tabsWithIconAndText = [
{
id: 0,
text: 'User',
icon: 'user',
},
{
id: 1,
text: 'Analytics',
icon: 'chart',
},
{
id: 2,
text: 'Clients',
icon: 'accountbox',
},
{
id: 3,
text: 'Orders',
icon: 'ordersbox',
},
{
id: 4,
text: 'Favorites',
icon: 'bookmark',
},
{
id: 5,
text: 'Search',
icon: 'search',
},
];
export const tabsWithIcon = [
{
id: 0,
icon: 'user',
},
{
id: 1,
icon: 'chart',
},
{
id: 2,
icon: 'accountbox',
},
{
id: 3,
icon: 'ordersbox',
},
{
id: 4,
icon: 'bookmark',
},
{
id: 5,
icon: 'search',
},
];
export const orientations: Orientation[] = ['horizontal', 'vertical'];
export const stylingModes: DxTabsTypes.TabsStyle[] = [
'primary',
'secondary',
];
export const iconPositions: DxTabsTypes.TabsIconPosition[] = [
'top',
'start',
'end',
'bottom',
];
import { createApp } from 'vue';
import App from './App.vue';
createApp(App).mount('#app');
<!DOCTYPE html>
<html lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/25.2.6/css/dx.light.css" />
<script src="https://cdn.jsdelivr.net/npm/typescript@5.9.3/lib/typescript.js"></script>
<script type="module">
import * as vueCompilerSFC from "https://cdn.jsdelivr.net/npm/@vue/compiler-sfc@3.4.27/dist/compiler-sfc.esm-browser.js";
window.vueCompilerSFC = vueCompilerSFC;
</script>
<script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script>
<script type="text/javascript" src="config.js"></script>
<script type="text/javascript">
System.import("./index.ts");
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div id="app"> </div>
</div>
</body>
</html>

<div class="tabs-demo">
<div class="widget-container">
<div
[class.widget-wrapper]="widgetWrapperClasses['widget-wrapper']"
[class.widget-wrapper-horizontal]="
widgetWrapperClasses['widget-wrapper-horizontal']
"
[class.widget-wrapper-vertical]="
widgetWrapperClasses['widget-wrapper-vertical']
"
[class.strict-width]="widgetWrapperClasses['strict-width']"
>
<dx-tabs
#withText
[width]="width"
[selectedIndex]="0"
[rtlEnabled]="rtlEnabled"
[scrollByContent]="scrollByContent"
[showNavButtons]="showNavButtons"
[dataSource]="tabsWithText"
[orientation]="orientation"
[stylingMode]="stylingMode"
[iconPosition]="iconPosition"
></dx-tabs>
<dx-tabs
#withIconAndText
[width]="width"
[selectedIndex]="0"
[rtlEnabled]="rtlEnabled"
[scrollByContent]="scrollByContent"
[showNavButtons]="showNavButtons"
[dataSource]="tabsWithIconAndText"
[orientation]="orientation"
[stylingMode]="stylingMode"
[iconPosition]="iconPosition"
></dx-tabs>
<dx-tabs
#withIcon
[width]="width"
[selectedIndex]="0"
[rtlEnabled]="rtlEnabled"
[scrollByContent]="scrollByContent"
[showNavButtons]="showNavButtons"
[dataSource]="tabsWithIcon"
[orientation]="orientation"
[stylingMode]="stylingMode"
[iconPosition]="iconPosition"
></dx-tabs>
</div>
</div>
<div class="options">
<div class="caption">Options</div>
<div class="option">
<span>Orientation</span>
<dx-select-box
[inputAttr]="{ 'aria-label': 'Orientation' }"
[items]="orientations"
[(value)]="orientation"
(onValueChanged)="onOrientationChanged($event)"
></dx-select-box>
</div>
<div class="option">
<span>Styling mode</span>
<dx-select-box
[inputAttr]="{ 'aria-label': 'Styling Mode' }"
[items]="stylingModes"
[(value)]="stylingMode"
></dx-select-box>
</div>
<div class="option">
<span>Icon position</span>
<dx-select-box
[inputAttr]="{ 'aria-label': 'Icon Position' }"
[items]="iconPositions"
[(value)]="iconPosition"
></dx-select-box>
</div>
<div class="option">
<dx-check-box
id="show-navigation-buttons"
text="Show navigation buttons"
[(value)]="showNavButtons"
(onValueChanged)="toggleStrictWidthClass()"
></dx-check-box>
</div>
<div class="option">
<dx-check-box
text="Scroll content"
[(value)]="scrollByContent"
(onValueChanged)="toggleStrictWidthClass()"
></dx-check-box>
</div>
<div class="option">
<dx-check-box
text="Full width"
[value]="false"
(onValueChanged)="onFullWidthChanged($event)"
></dx-check-box>
</div>
<div class="option">
<dx-check-box
text="Right-to-left mode"
[(value)]="rtlEnabled"
></dx-check-box>
</div>
</div>
</div>
import { bootstrapApplication } from '@angular/platform-browser';
import { Component, enableProdMode, ViewChild, provideZoneChangeDetection } from '@angular/core';
import { DxSelectBoxModule, DxSelectBoxTypes } from 'devextreme-angular/ui/select-box';
import { DxCheckBoxModule, DxCheckBoxTypes } from 'devextreme-angular/ui/check-box';
import { DxTabsModule, DxTabsComponent, DxTabsTypes } from 'devextreme-angular/ui/tabs';
import { Tab, Service } from './app.service';
if (!/localhost/.test(document.location.host)) {
enableProdMode();
}
let modulePrefix = '';
// @ts-ignore
if (window && window.config?.packageConfigPaths) {
modulePrefix = '/app';
}
@Component({
selector: 'demo-app',
templateUrl: `app/app.component.html`,
styleUrls: [`app/app.component.css`],
providers: [Service],
imports: [
DxTabsModule,
DxCheckBoxModule,
DxSelectBoxModule,
],
})
export class AppComponent {
@ViewChild('withText') withText: DxTabsComponent;
@ViewChild('withIconAndText') withIconAndText: DxTabsComponent;
@ViewChild('withIcon') withIcon: DxTabsComponent;
tabsWithText: Tab[];
tabsWithIconAndText: Tab[];
tabsWithIcon: Tab[];
showNavButtons = false;
scrollByContent = false;
rtlEnabled = false;
orientations: DxTabsTypes.Orientation[] = ['horizontal', 'vertical'];
stylingModes: DxTabsTypes.TabsStyle[] = ['primary', 'secondary'];
iconPositions: DxTabsTypes.TabsIconPosition[] = ['top', 'start', 'end', 'bottom'];
width = 'auto';
orientation = this.orientations[0];
stylingMode = this.stylingModes[1];
iconPosition = this.iconPositions[0];
widgetWrapperClasses = {
'widget-wrapper': true,
'widget-wrapper-horizontal': true,
'widget-wrapper-vertical': false,
'strict-width': false,
};
constructor(service: Service) {
this.tabsWithText = service.getTabsWithText();
this.tabsWithIconAndText = service.getTabsWithIconAndText();
this.tabsWithIcon = service.getTabsWithIcon();
}
onOrientationChanged(e: DxSelectBoxTypes.ValueChangedEvent) {
if (e.value === 'vertical') {
this.widgetWrapperClasses['widget-wrapper-vertical'] = true;
this.widgetWrapperClasses['widget-wrapper-horizontal'] = false;
} else {
this.widgetWrapperClasses['widget-wrapper-horizontal'] = true;
this.widgetWrapperClasses['widget-wrapper-vertical'] = false;
}
}
toggleStrictWidthClass() {
this.widgetWrapperClasses['strict-width'] = this.scrollByContent || this.showNavButtons;
}
onFullWidthChanged(e: DxCheckBoxTypes.ValueChangedEvent) {
this.width = e.value ? '100%' : 'auto';
}
}
bootstrapApplication(AppComponent, {
providers: [
provideZoneChangeDetection({ eventCoalescing: true, runCoalescing: true }),
],
});
::ng-deep .tabs-demo {
display: flex;
}
::ng-deep .strict-width {
max-width: 340px;
}
::ng-deep .dx-theme-generic .strict-width {
max-width: 250px;
}
::ng-deep .widget-container {
display: flex;
align-items: center;
justify-content: center;
flex-grow: 1;
width: 100%;
min-width: 200px;
padding: 16px 32px;
overflow: clip;
}
::ng-deep .widget-wrapper {
display: inline-flex;
flex-direction: column;
align-items: center;
justify-content: center;
gap: 80px;
width: 100%;
}
::ng-deep .widget-wrapper-vertical {
width: 100%;
flex-direction: row;
align-items: center;
}
.options {
display: flex;
flex-direction: column;
flex-shrink: 0;
padding: 20px;
background-color: rgba(191, 191, 191, 0.15);
}
.caption {
font-weight: 500;
font-size: 18px;
}
::ng-deep #show-navigation-buttons {
margin-top: 22px;
}
.option {
margin-top: 20px;
}
::ng-deep .dx-tabs {
max-width: 100%;
}
::ng-deep .dx-tabs-vertical {
height: 216px;
}
::ng-deep .dx-viewport:not(.dx-theme-generic) .dx-tabs-horizontal {
border-block-end: 1px solid rgb(225, 225, 225, 0.4);
}
::ng-deep .dx-viewport:not(.dx-theme-generic) .dx-tabs-vertical {
height: 232px;
border-inline-end: 1px solid rgb(225, 225, 225, 0.4);
}
import { Injectable } from '@angular/core';
export class Tab {
id: number;
text?: string;
icon?: string;
}
const tabsWithText: Tab[] = [
{
id: 0,
text: 'User',
},
{
id: 1,
text: 'Analytics',
},
{
id: 2,
text: 'Clients',
},
{
id: 3,
text: 'Orders',
},
{
id: 4,
text: 'Favorites',
},
{
id: 5,
text: 'Search',
},
];
const tabsWithIcon: Tab[] = [
{
id: 0,
icon: 'user',
},
{
id: 1,
icon: 'chart',
},
{
id: 2,
icon: 'accountbox',
},
{
id: 3,
icon: 'ordersbox',
},
{
id: 4,
icon: 'bookmark',
},
{
id: 5,
icon: 'search',
},
];
const tabsWithIconAndText: Tab[] = [
{
id: 0,
text: 'User',
icon: 'user',
},
{
id: 1,
text: 'Analytics',
icon: 'chart',
},
{
id: 2,
text: 'Clients',
icon: 'accountbox',
},
{
id: 3,
text: 'Orders',
icon: 'ordersbox',
},
{
id: 4,
text: 'Favorites',
icon: 'bookmark',
},
{
id: 5,
text: 'Search',
icon: 'search',
},
];
@Injectable()
export class Service {
getTabsWithText(): Tab[] {
return tabsWithText;
}
getTabsWithIconAndText(): Tab[] {
return tabsWithIconAndText;
}
getTabsWithIcon(): Tab[] {
return tabsWithIcon;
}
}
// In real applications, you should not transpile code in the browser.
// You can see how to create your own application with Angular and DevExtreme here:
// https://js.devexpress.com/Documentation/Guide/Angular_Components/Getting_Started/Create_a_DevExtreme_Application/
const componentNames = [
'accordion',
'action-sheet',
'autocomplete',
'bar-gauge',
'box',
'bullet',
'button-group',
'button',
'calendar',
'card-view',
'chart',
'chat',
'check-box',
'circular-gauge',
'color-box',
'context-menu',
'data-grid',
'date-box',
'date-range-box',
'defer-rendering',
'diagram',
'draggable',
'drawer',
'drop-down-box',
'drop-down-button',
'file-manager',
'file-uploader',
'filter-builder',
'form',
'funnel',
'gallery',
'gantt',
'html-editor',
'linear-gauge',
'list',
'load-indicator',
'load-panel',
'lookup',
'map',
'menu',
'multi-view',
'nested',
'number-box',
'pagination',
'pie-chart',
'pivot-grid-field-chooser',
'pivot-grid',
'polar-chart',
'popover',
'popup',
'progress-bar',
'radio-group',
'range-selector',
'range-slider',
'recurrence-editor',
'resizable',
'responsive-box',
'sankey',
'scheduler',
'scroll-view',
'select-box',
'slider',
'sortable',
'sparkline',
'speech-to-text',
'speed-dial-action',
'splitter',
'stepper',
'switch',
'tab-panel',
'tabs',
'tag-box',
'text-area',
'text-box',
'tile-view',
'toast',
'toolbar',
'tooltip',
'tree-list',
'tree-map',
'tree-view',
'validation-group',
'validation-summary',
'validator',
'vector-map',
];
window.exports = window.exports || {};
window.config = {
transpiler: 'ts',
typescriptOptions: {
module: 'system',
emitDecoratorMetadata: true,
experimentalDecorators: true,
},
meta: {
'typescript': {
'exports': 'ts',
},
'devextreme/time_zone_utils.js': {
'esModule': true,
},
'devextreme/localization.js': {
'esModule': true,
},
'devextreme/viz/palette.js': {
'esModule': true,
},
'@angular/platform-browser-dynamic': {
'esModule': true,
},
'@angular/platform-browser': {
'esModule': true,
},
'@angular/core': {
'esModule': true,
},
'@angular/common': {
'esModule': true,
},
'@angular/common/http': {
'esModule': true,
},
'@angular/animations': {
'esModule': true,
},
'@angular/forms': {
'esModule': true,
},
'openai': {
'esModule': true,
},
},
paths: {
'npm:': 'https://cdn.jsdelivr.net/npm/',
'bundles:': '../../../../bundles/',
'externals:': '../../../../bundles/externals/',
'anti-forgery:': '../../../../shared/anti-forgery/',
},
map: {
'anti-forgery': 'anti-forgery:fetch-override.js',
'ts': 'npm:plugin-typescript@8.0.0/lib/plugin.js',
'typescript': 'npm:typescript@4.2.4/lib/typescript.js',
'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js',
/* @angular */
'@angular/compiler': 'bundles:@angular/compiler.umd.js',
'@angular/platform-browser-dynamic': 'bundles:@angular/platform-browser-dynamic.umd.js',
'@angular/core': 'bundles:@angular/core.umd.js',
'@angular/core/primitives/signals': 'bundles:@angular/core.primitives.signals.umd.js',
'@angular/core/primitives/di': 'bundles:@angular/core.primitives.di.umd.js',
'@angular/common': 'bundles:@angular/common.umd.js',
'@angular/common/http': 'bundles:@angular/common-http.umd.js',
'@angular/platform-browser': 'bundles:@angular/platform-browser.umd.js',
'@angular/platform-browser/animations': 'bundles:@angular/platform-browser.umd.js',
'@angular/forms': 'bundles:@angular/forms.umd.js',
/* devextreme */
'devextreme': 'npm:devextreme@link:../../packages/devextreme/artifacts/npm/devextreme/cjs',
'devextreme-quill': 'npm:devextreme-quill@1.7.8/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.25',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.66',
/* devextreme-angular umd maps */
'devextreme-angular': 'bundles:devextreme-angular/devextreme-angular.umd.js',
'devextreme-angular/common/ai-integration': 'bundles:devextreme-angular/devextreme-angular-common-ai-integration.umd.js',
'devextreme-angular/core': 'bundles:devextreme-angular/devextreme-angular-core.umd.js',
'devextreme-angular/common/charts': 'bundles:devextreme-angular/devextreme-angular-common-charts.umd.js',
'devextreme-angular/common/core/animation': 'bundles:devextreme-angular/devextreme-angular-common-core-animation.umd.js',
'devextreme-angular/common/core/environment': 'bundles:devextreme-angular/devextreme-angular-common-core-environment.umd.js',
'devextreme-angular/common/core/events': 'bundles:devextreme-angular/devextreme-angular-common-core-events.umd.js',
'devextreme-angular/common/core/localization': 'bundles:devextreme-angular/devextreme-angular-common-core-localization.umd.js',
'devextreme-angular/common/core': 'bundles:devextreme-angular/devextreme-angular-common-core.umd.js',
'devextreme-angular/common/data/custom-store': 'bundles:devextreme-angular/devextreme-angular-common-data-custom-store.umd.js',
'devextreme-angular/common/data': 'bundles:devextreme-angular/devextreme-angular-common-data.umd.js',
'devextreme-angular/common/export/excel': 'bundles:devextreme-angular/devextreme-angular-common-export-excel.umd.js',
'devextreme-angular/common/export/pdf': 'bundles:devextreme-angular/devextreme-angular-common-export-pdf.umd.js',
'devextreme-angular/common/export': 'bundles:devextreme-angular/devextreme-angular-common-export.umd.js',
'devextreme-angular/common/grids': 'bundles:devextreme-angular/devextreme-angular-common-grids.umd.js',
'devextreme-angular/common': 'bundles:devextreme-angular/devextreme-angular-common.umd.js',
'devextreme-angular/http': 'bundles:devextreme-angular/devextreme-angular-http.umd.js',
'devextreme-angular/core/tokens': 'bundles:devextreme-angular/devextreme-angular-core-tokens.umd.js',
...componentNames.reduce((acc, name) => {
acc[`devextreme-angular/ui/${name}`] = `bundles:devextreme-angular/devextreme-angular-ui-${name}.umd.js`;
acc[`devextreme-angular/ui/${name}/nested`] = `bundles:devextreme-angular/devextreme-angular-ui-${name}-nested.umd.js`;
return acc;
}, {}),
'tslib': 'npm:tslib/tslib.js',
'rxjs': 'npm:rxjs@7.5.3/dist/bundles/rxjs.umd.js',
'rxjs/operators': 'npm:rxjs@7.5.3/dist/cjs/operators/index.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign',
'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
'@preact/signals-core': 'npm:@preact/signals-core@1.8.0/dist/signals-core.min.js',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.8/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js',
'zone.js': 'npm:zone.js@0.15.1/bundles/zone.umd.js',
},
packages: {
'app': {
main: './app.component.ts',
defaultExtension: 'ts',
},
'devextreme': {
defaultExtension: 'js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/common/core/events/utils': {
main: 'index',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
'rxjs': {
defaultExtension: 'js',
},
'rxjs/operators': {
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
'npm:rxjs@7.5.3/package.json',
'npm:rxjs@7.5.3/operators/package.json',
'npm:devexpress-diagram@2.2.25/package.json',
'npm:devexpress-gantt@4.1.66/package.json',
],
};
window.process = {
env: {
NODE_ENV: 'production',
},
};
System.config(window.config);
// eslint-disable-next-line no-console
// System.import('@angular/compiler').catch(console.error.bind(console));
// eslint-disable-next-line
const useTgzInCSB = ['openai'];
let packagesInfo = {
"@angular/core": {
"version": "21.0.7"
},
"core-js": {
"version": "2.6.12"
},
"typescript": {
"version": "5.9.3"
},
"zone.js": {
"version": "0.15.1"
}
};
<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/25.2.5/css/dx.light.css" />
<script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/zone.js@0.15.1/bundles/zone.umd.js"></script>
<script src="https://cdn.jsdelivr.net/npm/reflect-metadata@0.1.13/Reflect.js"></script>
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script>
<script src="config.js"></script>
<script>
System.import("app").catch(console.error.bind(console));
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<demo-app>Loading...</demo-app>
</div>
</body>
</html>